var gulp = require('gulp'),
    gutil = require('gulp-util'),
    ts = require('gulp-typescript'),
    wpPot = require('gulp-wp-pot'),
    sort = require('gulp-sort'),
    del = require('del'),
    minify = require('gulp-minify');

var tsProjectClient = ts.createProject('tsconfig.json');

var gulpConfig = {
    repoDirectory: 'D:/dev/jpibfi/trunk'
};

gulp.task('ts', function () {
    var tsResultClient = tsProjectClient.src()
        .pipe(ts(tsProjectClient)).js
        .pipe(minify())
        .pipe(gulp.dest(''));
    return tsResultClient;
});

gulp.task('pot', function () {
    return gulp.src('**/*.php')
        .pipe(sort())
        .pipe(wpPot({
            domain: 'jquery-pin-it-button-for-images',
            destFile: 'jquery-pin-it-button-for-images.pot',
            package: 'jquery-pin-it-button-for-images',
            team: 'Marcin Skrzypiec'
        }))
        .pipe(gulp.dest('languages'));
});

gulp.task('watch', function (cb) {
    gulp.watch('js/src/**/*.ts', ['ts']);
});

gulp.task('clean-repo', function () {
    return del.sync([
        gulpConfig.repoDirectory,
    ], { 
        force: true 
    });
});

gulp.task('copy-to-repo', function () {
    gulp
        .src([
            './**/*.*',
            '!./node_modules/**',
            '!./typings/**'
        ],
            { dot: true })
        .pipe(gulp.dest(gulpConfig.repoDirectory));
});

gulp.task('repo', ['clean-repo', 'copy-to-repo']);