module jpibfi {
    export interface ILogger {
        logString(msg: string): void;
        logObject(obj: Object): void;
    }

    export class Logger implements ILogger {
        private _printLog: boolean;
        private _jsonStringifyExists: boolean;

        private _logObject(obj: Object) {
            var out = '';
            for (var p in obj)
                out += p + ': ' + obj[p] + '\n';
            console.log('jpibfi debug: ' + out);
        }

        constructor(printLog: boolean) {
            this._printLog = printLog && typeof console !== 'undefined' && typeof console.log !== 'undefined';
            this._jsonStringifyExists = typeof JSON !== 'undefined' && typeof JSON.stringify === 'function';
        }

        logString(message: string) {
            if (!this._printLog)
                return;
            console.log('jpibfi debug: ' + message);
        }

        logObject(obj: Object) {
            if (!this._printLog)
                return;
            if (this._jsonStringifyExists)
                console.log('jpibfi debugz: ' + JSON.stringify(obj, null, 4));
            else
                this._logObject(obj);
        }
    }

}